package jiaocaiziliao

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaocaiziliao/model"
)

type document struct {
	Table
	create string `name:"create subject* grade* document_type*:select title* content* icon link" role:"teacher"`
}

func (s document) Create(m *ice.Message, arg ...string) {
	arg = kit.TransArgKeys(arg, model.DOCUMENT_TYPE, model.TYPE)
	s.Table.Create(m, kit.Simple(arg, m.OptionSimple(model.USER_UID, model.LIBRARY_UID))...)
}
func (s document) Remove(m *ice.Message, arg ...string) {
	s.Table.Remove(m, m.OptionSimple(model.USER_UID, model.UID)...)
}
func (s document) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.LIBRARY_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.LIBRARY_UID, arg[0], model.UID, arg[1])
	}
	m.RenameAppend(model.TYPE, model.DOCUMENT_TYPE).PushAction(s.Remove)
}

func init() { ice.TeamCtxCmd(document{}) }

type DocumentType int

const (
	DocumentBook DocumentType = iota
	DocumentPaper
)

var DocumentTypeList = map[DocumentType]string{
	DocumentBook:  "book",
	DocumentPaper: "paper",
}

func (s DocumentType) String() string { return DocumentTypeList[s] }
